<template>
  <!-- 
      1. Ho convertito l'Option API in Composition API
      2. Ho sostituito il check sulle named slots con delle computed che mi ritornano se la namedslot esiste (prima era gestito da un mixin)
      3. Ho installato la libreria mitt come consigliato nella documentazione, per creare event-bus, in quanto in vue3 i metodi $on e $off sono stati rimosso.
    -->
  <div class="WaYoutubeMediaPlayer">
    <div class="container-fluid">
      <div class="row justify-content-center">
        <div class="col-md-10">
          <div
            :class="['responsive-video', { playing }]"
            :style="{ backgroundImage: `url(${dataBackgroundImageSrc})` }"
          >
            <div ref="playerWrapper" />
            <div
              v-if="hasDurationSlot 
              || hasTitleSlot"
              class="info d-none d-sm-flex"
            >
              <slot name="duration" />
              <slot name="title" />
            </div>
            <button 
            v-if="ready" 
            class="play" 
            type="button" 
            @click="playVideo"
            >
              <svg class="icon">
                <use href="#icon-play" />
              </svg>
            </button>
          </div>
          <div 
            class="d-sm-none title-mobile"
          >
            <slot name="title" />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import mitt from "mitt";
import { ref, computed, onMounted, onBeforeUnmount, Comment } from "vue";
export default {
  name: 'WaYoutubeMediaPlayer',
  props: {
    dataBackgroundImageSrc: { type: String, required: true },
    dataYoutubeVideoId: { type: String, required: true },
  },
  setup(props, context) {
    /**
     * I metodi $on, $once, e $off sono stati rimossi dall'istanza di vue, quindi Vue 3 non possono essere usati per creare event-bus. La documentazione di vue raccomanda l'utilizzo della libreria mitt
     * mitt().on --> ascoltare un evento
     * mitt().emit --> emettere un evento
     */
    const initialized = ref(false);
    const playerWrapper = ref(null);
    const player = ref(null);
    const ready = ref(false);
    const playing = ref(false);
    const emitter = mitt();

    onMounted(() => {
      if (typeof window.YT === "object") {
        init();
      } else {
        emitter.on("on-you-tube-iframe-apiready", init);
        console.log('emitter')
        if (typeof window.onYouTubeIframeAPIReady === "undefined") {
          window.onYouTubeIframeAPIReady = () => {
            emitter.emit("on-you-tube-iframe-apiready");
          };
          const tag = document.createElement("script");
          tag.src = "http://www.youtube.com/iframe_api"
          const firstScriptTag = document.getElementsByTagName("script")[0];
          firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);
        }
      }
    });
    onBeforeUnmount(() => {
      if (player.value) {
        player.value.stopVideo();
        player.value.destroy();
        player.value = null;
        playing.value = false;
        ready.value = false;
        initialized.value = false;
      }
    });

    const hasDurationSlot = computed(() => {
      return (
        context.slots.duration &&
        context.slots.duration().findIndex(o => o.type !== Comment) !== -1
      );
    });
    const hasTitleSlot = computed(() => {
      return (
        context.slots.title &&
        context.slots.title().findIndex(o => o.type !== Comment) !== -1
      );
    });
    function init() {
      if (initialized.value) {
        return false;
      }
      initialized.value = true;
      player.value = new window.YT.Player(playerWrapper.value, {
        videoId: props.dataYoutubeVideoId,
        host: "http://www.youtube-nocookie.com",
        events: {
          onReady: onPlayerReady,
          onStateChange: onPlayerStateChange
        }
      });
      console.log(player.value)
    }
    function onPlayerReady() {
      ready.value = true;
    }
    function onPlayerStateChange(event) {
      if (
        event.data === window.YT.PlayerState.ENDED ||
        event.data === window.YT.PlayerState.PAUSED
      ) {
        playing.value = false;
      }
    }
    function playVideo() {
      player.value.playVideo();
      playing.value = true;
    }
    return {
      playerWrapper,
      hasDurationSlot,
      hasTitleSlot,
      player,
      ready,
      playing,
      playVideo
    };
  }
};
</script>

<style lang="scss" scoped>
@import "../scss/_variables.scss";
@import "~bootstrap/scss/mixins/breakpoints";

.responsive-video {
  width: 100%;
  background: $color-black no-repeat 50% 50%;
  background-size: cover;
  height: 0;
  padding-bottom: (3 * 100% / 4);
  position: relative;

  &:before {
    content: " ";
    display: block;
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    z-index: 1;
    background: rgba($color-black, 0.5);
  }

  @include media-breakpoint-only(md) {
    height: 590px;
    padding-bottom: 0;
  }

  @include media-breakpoint-up(lg) {
    padding-bottom: (9 * 100% / 16);
  }

  :deep(iframe) {
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    z-index: 10;
    opacity: 0;
    transition: opacity 0.6s ease-in-out;
    pointer-events: none;
  }

  &.playing {
    :deep(iframe) {
      opacity: 1;
      pointer-events: auto;
    }
  }
}

.info {
  position: absolute;
  left: 24px;
  bottom: 24px;
  z-index: 2;
  display: flex;
  align-items: center;

  @include media-breakpoint-up(md) {
    left: 32px;
    bottom: 32px;
  }

  > p {
    margin: 0 0 0 16px;
    position: relative;
    padding-left: 17px;

    &:before {
      content: ' ';
      display: block;
      width: 1px;
      height: 18px;
      background: currentColor;
      position: absolute;
      left: 0;
      top: 50%;
      margin-top: -9px;
    }

    &:first-child {
      margin: 0;
      padding: 0;

      &:before {
        display: none;
      }
    }
  }
}

.title-mobile{
  margin-top: 15px;
  :deep([class^="typo-"],[class^="text-color-"],p) {
    color: $color-black !important;
  }
}

.play {
  position: absolute;
  left: 0;
  top: 0;
  z-index: 5;
  width: 100%;
  height: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  border: 0;
  padding: 0;
  margin: 0;
  background: none;
  cursor: pointer;
  color: rgba($color-white, .75);

  //font-size: 60px;

  /*@include media-breakpoint-up(md) {
      font-size: 80px;
    }*/

  .icon {
    display: block;
    width: 64px;
    height: 64px;
    fill: rgba($color-white, .75);

    @media (min-width: $bootstrap-sm) {
      width: 96px;
      height: 96px;
    }
  }
}
</style>